/*/This takes a message from the bluetooth terminal and prints it on the screen
  once this program is running move to the bluetooth terminal and add the text from there
  Any ASCII character can be used, commands for changing the speed and colour are given below
*/
boolean MessageRunning;

int l = 0;
String message; // string to contain the message from the bluetooth serial
int  MessageRecieved; // indicator
int textspeed = 60; //basic text speed
int ColorSelector = 0; // start off on red but can scroll to others

void MessageInit() {
  //initialisation of the program, fluch the serial to remove commands that are from buttons
  MessageRunning = true;
  Serial1.flush();
  waitMessage();
  MessageRecieved = 0;
  message = ""; // clear the message variable from previous iterations

}

void runMessage() {
  MessageInit();
  unsigned long prevUpdateTime = 0;
  unsigned long curTime = 0;

  while (MessageRunning) {

    //check if message has been recieved before looking for another
    if (MessageRecieved == 0) {
      delay(50);
      while (Serial1.available() > 0) {
        //char MessageChar[Serial.available()];
        char inChar = Serial1.read();
        delay(10);
        message += inChar; //incrementally adds to the char array until the serial buffer is empty
        l = message.length();
        // if the length of the string is 0 then it is assumed that no message
        //is recieved. If it is longer than 0 then message recieved
        if (l != 0) {
          MessageRecieved = 1;
        }
        else {
          MessageRecieved = 0;
        }
      }

    }
    Serial.println(MessageRecieved);
    if (MessageRecieved == 1) {
      l = message.length();

      char MessageChar[l + 1]; // added space to contain the null character.
      // This does not work as well using the PC serial terminal
      int dispL = l;
      //s="hello";
      message.toCharArray(MessageChar, l + 1);
      Serial.println(MessageChar);
      //scrollTextBlocked(MessageChar,l,WHITE);
      for (int x = FIELD_WIDTH; x > -(dispL * 8); x--) {
        printText(MessageChar, dispL, x, (FIELD_HEIGHT - 8) / 2, colorLib[ColorSelector]);
        //Read buttons
        unsigned long curTime;
        do {
          /* Select exits the message loop
            Start resets the message
            Left and right speed up/slow down
            up and down change the colours */
        readInput();
        if (curControl == BTN_EXIT) {
          Serial.println("EXIT");
          MessageRunning = false;
          for ( int i = 0; i == l; i++) {
            MessageChar[i] = (char)0;
          }
          break;
        }
        if (curControl == BTN_UP) {
          ColorSelector = ColorSelector + 1;
          if (ColorSelector == 10) {
            ColorSelector = 0;
          }
        }
        if (curControl == BTN_DOWN) {
          ColorSelector = ColorSelector - 1;
          if (ColorSelector == 0) {
            ColorSelector = 10;
          }
        }
        if (curControl == BTN_LEFT) {
          textspeed = textspeed + 10;
          Serial.print("Slower");
        }
        if (curControl == BTN_RIGHT) {
          textspeed = textspeed - 10;
          if (textspeed == 0) {
            textspeed = 10;
          }
          Serial.print("Faster");
        }

        curTime = millis();
      } while (((curTime - prevUpdateTime) < textspeed) && (curControl == BTN_NONE));//Once enough time  has passed, proceed
      prevUpdateTime = curTime;
    }

  }








  delay(50);
}
}



void waitMessage() {
  // displays holding message
  char* Instructions;
  Instructions = "Message.";
  scrollTextBlocked(Instructions, 8, WHITE);
}

