/* LedTable
 *
 * Written by: Ing. David Hrbaty Modified by: Mark Quinn
 * 
 * Common code and defines for the Dice game
 */
 
PROGMEM const boolean diceOne[12][12] = {
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},                
               };

PROGMEM const boolean diceTwo[12][12] = {
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},          
               };              

PROGMEM const boolean diceThree[12][12] = {
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},                
               };   

PROGMEM const boolean diceFour[12][12] = {
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0},
                 { 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0},
                 { 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},                  
               }; 

PROGMEM const boolean diceFive[12][12] = {
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0},
                 { 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0},
                 { 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},                
               }; 

PROGMEM const boolean diceSix[12][12] = {
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0},
                 { 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0},
                 { 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
                 { 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0},
                 { 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0},
                 { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},               
               }; 
               
               


                           
